#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char **argv) {
	FILE *input;
	FILE *output;
	FILE *outputh;
	char buf[256];
	char fun_name[256];
	char header_name[256];
	int i;
	unsigned char c;
	
	if(argc < 3) {
		fprintf(stderr, "Usage: %s <input> <output>\n", argv[0]);
		exit(-1);
	}
	
	if( (input = fopen(argv[1], "r")) == NULL) {
		perror("Can't open input file");
		exit(-1);
	}
	
	if( (output = fopen(argv[2], "w")) == NULL ) {
		perror("Can't open output file");
		exit(-1);
	}
	
	for(i=0; argv[1][i] != '\0' && argv[1][i] != '.'; i++) {
		buf[i] = argv[1][i];
	}
	buf[i] = '\0';
	
	strcpy(fun_name, "img_");
	strcat(fun_name, buf);
	
	for(i=0; argv[2][i] != '\0' && argv[2][i] != '.'; i++) {
		header_name[i] = argv[2][i];
	}
	header_name[i] = '\0';
	strcat(header_name, ".h");
	
	if( (outputh = fopen(header_name, "w")) == NULL ) {
		perror("Can't open output file");
		exit(-1);
	}
	
	i = 0;
	
	fprintf(output, "unsigned char %s[] = {\n", fun_name);
	
	while(!feof(input)) {
		fread(&c, 1, 1, input);
		if(i > 0) fprintf(output, ", ");
		if(i> 0 && i % 10 == 0) fprintf(output, "\n");
		fprintf(output, "0x%02x", c);
		i++;
	}
	
	fprintf(output, "\n};\n");
	
	fprintf(outputh, "extern unsigned char %s[%d];\n", fun_name, i);
	
	fclose(input);
	fclose(output);
	
	return 0;
	
}